diff --git a/base/deploy/src/scriptlets/pkimanifest.py b/base/deploy/src/scriptlets/pkimanifest.py
new file mode 100644
index 0000000..00d5c53
--- /dev/null
+++ b/base/deploy/src/scriptlets/pkimanifest.py
@@ -0,0 +1,90 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2011 Red Hat, Inc.
+# All rights reserved.
+#
+
+# System Imports
+from collections import namedtuple
+import csv
+
+
+# PKI Deployment Manifest Record Class
+class record(object):
+    __slots__= "name",\
+               "type",\
+               "user",\
+               "group",\
+               "uid",\
+               "gid",\
+               "permissions",\
+               "acls",
+
+    def items(self):
+        "dict style items"
+        return [
+            (field_name, getattr(self, field_name))
+            for field_name in self.__slots__]
+
+    def __iter__(self):
+        "iterate over fields tuple/list style"
+        for field_name in self.__slots__:
+            yield getattr(self, field_name)
+
+    def __getitem__(self, index):
+        "tuple/list style getitem"
+        return getattr(self, self.__slots__[index])
+
+
+# PKI Deployment Manifest File Class
+class file:
+    global database
+    filename = None
+
+    def register(self, name):
+        self.filename = name
+
+    def write(self):
+        try:
+            fd = open(self.filename, "wt")
+            c = csv.writer(fd)
+            for record in database:
+                c.writerow(tuple(record))
+            fd.close()
+        except IOError as exc:
+            config.pki_log.error(log.PKI_IOERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_1)
+            sys.exit(1)
+
+    def read(self):
+        try:
+            fd = open(self.filename, "rt")
+            cr = csv.reader(fd)
+            for row in cr:
+                print tuple(row)
+            fd.close()
+        except IOError as exc:
+            config.pki_log.error(log.PKI_IOERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_1)
+            sys.exit(1)
+
+
+# PKI Deployment Global Named Tuples
+database = []
+file = file()
+
diff --git a/base/deploy/src/scriptlets/pkimessages.py b/base/deploy/src/scriptlets/pkimessages.py
index e6a9f95..aee364f 100644
--- a/base/deploy/src/scriptlets/pkimessages.py
+++ b/base/deploy/src/scriptlets/pkimessages.py
@@ -20,17 +20,6 @@
 #
 
 # PKI Deployment Engine Messages
-PKI_CUSTOM_APACHE_INSTANCE_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, the 'instance', 'http_port', and "\
-                               "'https_port' must ALL be specified!"
-PKI_CUSTOM_TOMCAT_INSTANCE_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, the 'instance', 'http_port', "\
-                               "'https_port', and 'ajp_port' must ALL be "\
-                               "specified!"
-PKI_CUSTOM_TOMCAT_AJP_PORT_1 = "When a custom '%s' subsystem is being "\
-                               "deployed, ONLY the 'instance', "\
-                               "'http_port', and 'https_port' MUST be "\
-                               "specified; NO 'ajp_port' should be requested!"
 PKI_DICTIONARY_COMMON ="\n"\
 "=====================================================\n"\
 "    DISPLAY CONTENTS OF PKI COMMON DICTIONARY\n"\
@@ -47,6 +36,20 @@ PKI_DICTIONARY_WEB_SERVER="\n"\
 "=====================================================\n"\
 "    DISPLAY CONTENTS OF PKI WEB SERVER DICTIONARY\n"\
 "====================================================="
+
+
+# PKI Deployment Error Messages
+PKI_CUSTOM_APACHE_INSTANCE_1 = "When a custom '%s' subsystem is being "\
+                               "deployed, the 'instance', 'http_port', and "\
+                               "'https_port' must ALL be specified!"
+PKI_CUSTOM_TOMCAT_INSTANCE_1 = "When a custom '%s' subsystem is being "\
+                               "deployed, the 'instance', 'http_port', "\
+                               "'https_port', and 'ajp_port' must ALL be "\
+                               "specified!"
+PKI_CUSTOM_TOMCAT_AJP_PORT_1 = "When a custom '%s' subsystem is being "\
+                               "deployed, ONLY the 'instance', "\
+                               "'http_port', and 'https_port' MUST be "\
+                               "specified; NO 'ajp_port' should be requested!"
 PKI_DIRECTORY_ALREADY_EXISTS_1 = "Directory '%s' already exists!"
 PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1 = "Directory '%s' already "\
                                                  "exists BUT it is NOT a "\
@@ -55,6 +58,10 @@ PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 = "Directory '%s' is either "\
                                              "missing or is NOT a directory!"
 PKI_FILE_MISSING_OR_NOT_A_FILE_1 = "File '%s' is either missing "\
                                    "or is NOT a regular file!"
+PKI_IOERROR_1 = "IOError:  %s!"
+PKI_KEYERROR_1 = "KeyError:  %s!"
+PKI_MANIFEST_MESSAGE_1 = "generating manifest file called '%s'"
+PKI_OSERROR_1 = "OSError:  %s!"
 PKI_UNABLE_TO_PARSE_1 = "'Could not parse:  '%s'"
 PKI_UNABLE_TO_CREATE_LOG_DIRECTORY_1 = "Could not create log directory '%s'!"
 PKI_VERBOSITY_LEVELS_MESSAGE = "Only up to 3 levels of verbosity are supported!"
@@ -64,23 +71,46 @@ PKI_VERBOSITY_LEVELS_MESSAGE = "Only up to 3 levels of verbosity are supported!"
 PKIDESTROY_BEGIN_MESSAGE_2 = "BEGIN destroying subsystem '%s' of "\
                              "instance '%s' . . ."
 PKIDESTROY_END_MESSAGE_2 = "END destroying subsystem '%s' of "\
-                           "instance '%s'."
+                           "instance '%s'"
 PKIRESPAWN_BEGIN_MESSAGE_2 = "BEGIN respawning subsystem '%s' of "\
                              "instance '%s' . . ."
 PKIRESPAWN_END_MESSAGE_2 = "END respawning subsystem '%s' of "\
-                           "instance '%s'."
+                           "instance '%s'"
 PKISPAWN_BEGIN_MESSAGE_2 = "BEGIN spawning subsystem '%s' of "\
                            "instance '%s' . . ."
 PKISPAWN_END_MESSAGE_2 = "END spawning subsystem '%s' of "\
-                         "instance '%s'."
+                         "instance '%s'"
+
+
+# PKI Deployment "Helper" Messages
+PKIHELPER_USER_1 = "retrieving UID for '%s' . . ."
+PKIHELPER_UID_2 = "UID of '%s' is %s"
+PKIHELPER_GROUP_1 = "retrieving GID for '%s' . . ."
+PKIHELPER_GID_2 = "GID of '%s' is %s"
+PKIHELPER_MKDIR_1 = "mkdir -p %s"
+PKIHELPER_MODIFY_DIR_1 = "modifying '%s'"
+PKIHELPER_CHMOD_2 = "chmod %o %s"
+PKIHELPER_CHOWN_3 = "chown %s:%s %s"
+PKIHELPER_RMDIR_1 = "rmdir %s"
+PKIHELPER_RM_RF_1 = "rm -rf %s"
+PKIHELPER_DIRECTORY_IS_EMPTY_1 = "directory '%s' is empty"
+PKIHELPER_DIRECTORY_IS_NOT_EMPTY_1 = "directory '%s' is NOT empty"
+PKIHELPER_APACHE_INSTANCES_2 = "instance '%s' contains '%d' Apache PKI subsystems"
+PKIHELPER_PKI_SUBSYSTEM_INSTANCES_2 = "instance '%s' contains '%d' PKI subsystems"
+PKIHELPER_TOMCAT_INSTANCES_2 = "instance '%s' contains '%d' Tomcat PKI subsystems"
 
 
 # PKI Deployment "Scriptlet" Messages
-INSTANCE_DESTROY_1 = "    depopulating '%s'"
-INSTANCE_RESPAWN_1 = "    repopulating '%s'"
-INSTANCE_SPAWN_1 = "    populating '%s'"
-INSTANCE_SPAWN_MKDIR_1 = "        mkdir '%s'"
-SECURITY_DATABASES_DESTROY_1 = "    removing '%s'"
-SECURITY_DATABASES_RESPAWN_1 = "    regenerating '%s'"
-SECURITY_DATABASES_SPAWN_1 = "    generating '%s'"
+INSTANCE_DESTROY_1 = "depopulating '%s'"
+INSTANCE_RESPAWN_1 = "repopulating '%s'"
+INSTANCE_SPAWN_1 = "populating '%s'"
+SECURITY_DATABASES_DESTROY_1 = "removing '%s'"
+SECURITY_DATABASES_RESPAWN_1 = "regenerating '%s'"
+SECURITY_DATABASES_SPAWN_1 = "generating '%s'"
+SUBSYSTEM_DESTROY_1 = "depopulating '%s'"
+SUBSYSTEM_RESPAWN_1 = "repopulating '%s'"
+SUBSYSTEM_SPAWN_1 = "populating '%s'"
+WEBSERVER_DESTROY_1 = "depopulating '%s'"
+WEBSERVER_RESPAWN_1 = "repopulating '%s'"
+WEBSERVER_SPAWN_1 = "populating '%s'"
 
diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
new file mode 100644
index 0000000..52c04d5
--- /dev/null
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -0,0 +1,223 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2011 Red Hat, Inc.
+# All rights reserved.
+#
+
+# System Imports
+import ConfigParser
+import argparse
+import logging
+import os
+
+
+# PKI Deployment Imports
+import pkiconfig as config
+import pkimessages as log
+
+
+# PKI Deployment Helper Functions
+def process_command_line_arguments(argv):
+    "Read and process command-line options"
+    description = None
+    if os.path.basename(argv[0]) == 'pkispawn':
+        description = 'PKI Instance Installation and Configuration'
+    elif os.path.basename(argv[0]) == 'pkidestroy':
+        description = 'PKI Instance Removal'
+    parser = argparse.ArgumentParser(
+                 description=description,
+                 add_help=False,
+                 formatter_class=argparse.RawDescriptionHelpFormatter,
+                 epilog=config.PKI_DEPLOYMENT_VERBOSITY)
+    mandatory = parser.add_argument_group('mandatory arguments')
+    mandatory.add_argument('-s',
+                           dest='pki_subsystem', action='store',
+                           nargs=1, choices=config.PKI_SUBSYSTEMS,
+                           required=True, metavar='<subsystem>',
+                           help='where <subsystem> is '
+                                'CA, KRA, OCSP, RA, TKS, or TPS')
+    optional = parser.add_argument_group('optional arguments')
+    optional.add_argument('--dry_run',
+                          dest='pki_dry_run_flag', action='store_true',
+                          help='do not actually perform any actions')
+    optional.add_argument('-f',
+                          dest='pkideployment_cfg', action='store',
+                          nargs=1, metavar='<file>',
+                          help='overrides default configuration filename')
+    optional.add_argument('-h', '--help',
+                          dest='help', action='help',
+                          help='show this help message and exit')
+    optional.add_argument('-p',
+                          dest='pki_root_prefix', action='store',
+                          nargs=1, metavar='<prefix>',
+                          help='directory prefix to specify local directory')
+    if os.path.basename(argv[0]) == 'pkispawn':
+        optional.add_argument('-u',
+                              dest='pki_update_flag', action='store_true',
+                              help='update instance of specified subsystem')
+    optional.add_argument('-v',
+                          dest='pki_verbosity', action='count',
+                          help='display verbose information (details below)')
+    custom = parser.add_argument_group('custom arguments '
+                                       '(OVERRIDES configuration file values)')
+    custom.add_argument('-i',
+                        dest='pki_instance_name', action='store',
+                        nargs=1, metavar='<instance>',
+                        help='PKI instance name (MUST specify REQUIRED ports)')
+    custom.add_argument('--http_port',
+                        dest='pki_http_port', action='store',
+                        nargs=1, metavar='<port>',
+                        help='HTTP port (CA, KRA, OCSP, RA, TKS, TPS)')
+    custom.add_argument('--https_port',
+                        dest='pki_https_port', action='store',
+                        nargs=1, metavar='<port>',
+                        help='HTTPS port (CA, KRA, OCSP, RA, TKS, TPS)')
+    custom.add_argument('--ajp_port',
+                        dest='pki_ajp_port', action='store',
+                        nargs=1, metavar='<port>',
+                        help='AJP port (CA, KRA, OCSP, TKS)')
+    args = parser.parse_args()
+
+    config.pki_subsystem = str(args.pki_subsystem).strip('[\']')
+    if args.pki_dry_run_flag:
+        config.pki_dry_run_flag = args.pki_dry_run_flag
+    if not args.pkideployment_cfg is None:
+        config.pkideployment_cfg = str(args.pkideployment_cfg).strip('[\']')
+    if not os.path.exists(config.pkideployment_cfg) or\
+       not os.path.isfile(config.pkideployment_cfg):
+        print "ERROR:  " +\
+              log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %\
+              config.pkideployment_cfg
+        print
+        parser.print_help()
+        parser.exit(-1);
+    if not args.pki_root_prefix is None:
+        config.pki_root_prefix = str(args.pki_root_prefix).strip('[\']')
+    if config.pki_root_prefix is None or\
+       len(config.pki_root_prefix) == 0:
+        config.pki_root_prefix = ""
+    elif not os.path.exists(config.pki_root_prefix) or\
+         not os.path.isdir(config.pki_root_prefix):
+        print "ERROR:  " +\
+              log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 %\
+              config.pki_root_prefix
+        print
+        parser.print_help()
+        parser.exit(-1);
+    if os.path.basename(argv[0]) == 'pkispawn':
+        if args.pki_update_flag:
+            config.pki_update_flag = args.pki_update_flag
+    if args.pki_verbosity == 1:
+        config.pki_console_log_level = logging.INFO
+        config.pki_log_level = logging.INFO
+    elif args.pki_verbosity == 2:
+        config.pki_console_log_level = logging.INFO
+        config.pki_log_level = logging.DEBUG
+    elif args.pki_verbosity == 3:
+        config.pki_console_log_level = logging.DEBUG
+        config.pki_log_level = logging.DEBUG
+    elif args.pki_verbosity > 3:
+        print "ERROR:  " + log.PKI_VERBOSITY_LEVELS_MESSAGE
+        print
+        parser.print_help()
+        parser.exit(-1);
+    if not args.pki_instance_name is None:
+        config.pki_instance_name = str(args.pki_instance_name).strip('[\']')
+    if not args.pki_http_port is None:
+        config.pki_http_port = str(args.pki_http_port).strip('[\']')
+    if not args.pki_https_port is None:
+        config.pki_https_port = str(args.pki_https_port).strip('[\']')
+    if not args.pki_ajp_port is None:
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            config.pki_ajp_port = str(args.pki_ajp_port).strip('[\']')
+        else:
+            print "ERROR:  " +\
+                  log.PKI_CUSTOM_TOMCAT_AJP_PORT_1 %\
+                  config.pki_subsystem
+            print
+            parser.print_help()
+            parser.exit(-1);
+    if not args.pki_instance_name is None or\
+       not args.pki_http_port is None or\
+       not args.pki_https_port is None or\
+       not args.pki_ajp_port is None:
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            if args.pki_instance_name is None or\
+               args.pki_http_port is None or\
+               args.pki_https_port is None:
+                print "ERROR:  " + log.PKI_CUSTOM_APACHE_INSTANCE_1 %\
+                      config.pki_subsystem
+                print
+                parser.print_help()
+                parser.exit(-1);
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if args.pki_instance_name is None or\
+               args.pki_http_port is None or\
+               args.pki_https_port is None or\
+               args.pki_ajp_port is None:
+                print "ERROR:  " + log.PKI_CUSTOM_TOMCAT_INSTANCE_1 %\
+                      config.pki_subsystem
+                print
+                parser.print_help()
+                parser.exit(-1);
+    return
+
+
+def read_pki_configuration_file():
+    "Read configuration file sections into dictionaries"
+    rv = 0
+    try:
+        parser = ConfigParser.ConfigParser()
+        parser.read(config.pkideployment_cfg)
+        config.pki_common_dict = dict(parser._sections['Common'])
+        if config.pki_subsystem == "CA":
+            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
+            config.pki_subsystem_dict = dict(parser._sections['CA'])
+        elif config.pki_subsystem == "KRA":
+            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
+            config.pki_subsystem_dict = dict(parser._sections['KRA'])
+        elif config.pki_subsystem == "OCSP":
+            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
+            config.pki_subsystem_dict = dict(parser._sections['OCSP'])
+        elif config.pki_subsystem == "RA":
+            config.pki_web_server_dict = dict(parser._sections['Apache'])
+            config.pki_subsystem_dict = dict(parser._sections['RA'])
+        elif config.pki_subsystem == "TKS":
+            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
+            config.pki_subsystem_dict = dict(parser._sections['TKS'])
+        elif config.pki_subsystem == "TPS":
+            config.pki_web_server_dict = dict(parser._sections['Apache'])
+            config.pki_subsystem_dict = dict(parser._sections['TPS'])
+        # Insert empty record into dictionaries for "pretty print" statements
+        config.pki_common_dict[0] = None
+        config.pki_web_server_dict[0] = None
+        config.pki_subsystem_dict[0] = None
+    except ConfigParser.ParsingError, err:
+        rv = err
+    return rv
+
+
+def create_pki_master_dictionary():
+    "Create a single master PKI dictionary from the sectional dictionaries"
+    config.pki_master_dict = dict()
+    config.pki_master_dict.update(config.pki_common_dict)
+    config.pki_master_dict.update(config.pki_web_server_dict)
+    config.pki_master_dict.update(config.pki_subsystem_dict)
+    config.pki_master_dict.update(__name__="PKI Master Dictionary")
+    return
+
diff --git a/base/deploy/src/scriptlets/security_databases.py b/base/deploy/src/scriptlets/security_databases.py
index af47cbd..38a168a 100644
--- a/base/deploy/src/scriptlets/security_databases.py
+++ b/base/deploy/src/scriptlets/security_databases.py
@@ -42,15 +42,18 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
     def spawn(self):
         if not os.path.exists(self.pki_database_path):
-            config.pki_log.info(log.SECURITY_DATABASES_SPAWN_1, __name__)
+            config.pki_log.info(log.SECURITY_DATABASES_SPAWN_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
         elif not os.path.isdir(self.pki_database_path):
             config.pki_log.error(
                 log.PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1,
-                self.pki_database_path)
+                self.pki_database_path,
+                extra=config.PKI_INDENTATION_LEVEL_1)
             self.rv = -1
         else:
             config.pki_log.error(log.PKI_DIRECTORY_ALREADY_EXISTS_1,
-                                 self.pki_database_path)
+                                 self.pki_database_path,
+                                 extra=config.PKI_INDENTATION_LEVEL_1)
             self.rv = -1
         return self.rv
 
@@ -59,10 +62,12 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
            not os.path.isdir(self.pki_database_path):
             config.pki_log.error(
                 log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                self.pki_database_path)
+                self.pki_database_path,
+                extra=config.PKI_INDENTATION_LEVEL_1)
             self.rv = -1
         else:
-            config.pki_log.info(log.SECURITY_DATABASES_RESPAWN_1, __name__)
+            config.pki_log.info(log.SECURITY_DATABASES_RESPAWN_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
         return self.rv
 
     def destroy(self):
@@ -70,9 +75,11 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
            not os.path.isdir(self.pki_database_path):
             config.pki_log.error(
                 log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                self.pki_database_path)
+                self.pki_database_path,
+                extra=config.PKI_INDENTATION_LEVEL_1)
             self.rv = -1
         else:
-            config.pki_log.info(log.SECURITY_DATABASES_DESTROY_1, __name__)
+            config.pki_log.info(log.SECURITY_DATABASES_DESTROY_1, __name__,
+                                extra=config.PKI_INDENTATION_LEVEL_1)
         return self.rv
 
diff --git a/base/deploy/src/scriptlets/subsystem_layout.py b/base/deploy/src/scriptlets/subsystem_layout.py
new file mode 100644
index 0000000..c66d288
--- /dev/null
+++ b/base/deploy/src/scriptlets/subsystem_layout.py
@@ -0,0 +1,106 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2011 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    # instance-based subsystem base
+    pki_instance_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_root'] + "/" +\
+        config.pki_master_dict['pki_instance_name']
+    pki_subsystem_path = pki_instance_path + "/" +\
+        config.pki_master_dict['pki_subsystem'].lower()
+
+    # instance-based subsystem logs
+    pki_instance_log_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_log_root'] + "/" +\
+        config.pki_master_dict['pki_instance_name']
+    pki_subsystem_log_path = pki_instance_log_path + "/" +\
+        config.pki_master_dict['pki_subsystem'].lower()
+    pki_subsystem_signed_audit_log_path = pki_instance_log_path + "/" +\
+        config.pki_master_dict['pki_subsystem'].lower() + "/" +\
+        config.PKI_SIGNED_AUDIT_DIR
+
+    # instance-based subsystem configuration
+    pki_instance_configuration_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_configuration_root'] + "/" +\
+        config.pki_master_dict['pki_instance_name']
+    pki_subsystem_configuration_path = pki_instance_configuration_path + "/" +\
+        config.pki_master_dict['pki_subsystem'].lower()
+
+    # instance-based subsystem registry
+    pki_instance_registry_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_registry_root'] + "/" +\
+        config.pki_master_dict['pki_instance_name']
+    pki_subsystem_registry_path = pki_instance_registry_path + "/" +\
+        config.pki_master_dict['pki_subsystem'].lower()
+
+    def spawn(self):
+        config.pki_log.info(log.SUBSYSTEM_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish instance-based subsystem base
+        util.directory.create(self.pki_subsystem_path)
+        # establish instance-based subsystem logs
+        util.directory.create(self.pki_subsystem_log_path)
+        if config.pki_subsystem in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
+            util.directory.create(self.pki_subsystem_signed_audit_log_path)
+        # establish instance-based subsystem configuration
+        util.directory.create(self.pki_subsystem_configuration_path)
+        # establish instance-based subsystem registry
+        util.directory.create(self.pki_subsystem_registry_path)
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.SUBSYSTEM_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # update instance-based subsystem base
+        util.directory.modify(self.pki_subsystem_path)
+        # update instance-based subsystem logs
+        util.directory.modify(self.pki_subsystem_log_path)
+        if config.pki_subsystem in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
+            util.directory.modify(self.pki_subsystem_signed_audit_log_path)
+        # update instance-based subsystem configuration
+        util.directory.modify(self.pki_subsystem_configuration_path)
+        # update instance-based subsystem registry
+        util.directory.modify(self.pki_subsystem_registry_path)
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.SUBSYSTEM_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # remove instance-based subsystem base
+        util.directory.delete(self.pki_subsystem_path)
+        # remove instance-based subsystem logs
+        util.directory.delete(self.pki_subsystem_log_path)
+        # remove instance-based subsystem configuration
+        util.directory.delete(self.pki_subsystem_configuration_path)
+        # remove instance-based subsystem registry
+        util.directory.delete(self.pki_subsystem_registry_path)
+        return self.rv
+
